
// Import any other script files here, e.g.:
// import * as myModule from "./mymodule.js";

globalThis.conn = null

runOnStartup(async runtime =>
{
	// Code to run on the loading screen.
	// Note layouts, objects etc. are not yet available.
	
	await runtime.assets.loadScripts('peerjs.min.js')
	
	runtime.addEventListener("beforeprojectstart", () => OnBeforeProjectStart(runtime));
});

async function OnBeforeProjectStart(runtime)
{
	// Code to run just before 'On start of layout' on
	// the first layout. Loading has finished and initial
	// instances are created and available to use here.
	
	globalThis.peer = new Peer()
	
	console.log(globalThis.peer)
	
// 	get your id
	globalThis.peer.on('open', function(id) {
		console.log('My peer ID is: ' + id);
		runtime.globalVars.idMy = id
	  });
	  
// Update the status or go to home screen on connection closed

	globalThis.peer.on('close', function() { 
		console.log('You have closed the connections')
		runtime.goToLayout('Login')
	});

	  
// receive connection
	globalThis.peer.on('connection', function(conn) { 
	
		globalThis.conn = conn
	
		globalThis.conn.on('open', function() {
		// Receive messages
		
		globalThis.conn.on('data', function(data) {
		  console.log('Received', data);
		  
		  var username = data.split(';')[0]
		  var message = data.split(';')[1]
		  var type = data.split(';')[2]
		  
		  if(type == 'chat'){
			  c3_callFunction('saveMessage',[username,message])		  
		  }
		  else if(type == 'pos'){
			  c3_callFunction('setOppPos',[message])	
		  }
		  else if(type == 'fire'){
			  c3_callFunction('setOppFire',[message])	
		  }

		});
		
		
		globalThis.conn.on('close', function() { 
			console.log('The chat closed due as the peer disconnected')
			runtime.goToLayout('Login')
		});		
	
	});
	
	runtime.globalVars.MyNumber = 1
	runtime.goToLayout('Game')	
	
	})

	
	runtime.addEventListener("tick", () => Tick(runtime));
}

function Tick(runtime)
{
	// Code to run every tick
}
